<?xml version='1.0' encoding='UTF-8' ?>
<!--
@author pedro.garcia
@description Composite component para el almacenamiento en memoria de predios seleccionados

@version 2.0

PRE:
* se usa dentro de las páginas del proyecto que usan alguno de los templates que incluyen snc.js


D:
OJO: hacer el update de la tabla en el botón de eliminar uno de los predios NO SIRVE.
Aunque no dice que no encuentra el componente si se usa update="prediosSeleccionadosDT", de todas
formas no refresca la tabla; esa tabla aperece en el código fuente como idComponente:prediosSeleccionadosDT,
pero si se pone así en el update dice que no lo encuentra y genera un error.
La forma que funcionó para que hiciera el refresco de la tabla fue hacer update de la forma que la
contiene, y para referirse a ella hay que usar el nombre incluyendo el idComponente.
Funciona, pero es ineficiente porque refrescaría todos los comopnentes dentro de la forma
-->

<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:p="http://primefaces.org/ui"
      xmlns:composite="http://java.sun.com/jsf/composite">

    <composite:interface>

        <composite:attribute name="managedBean" required="true" default="consultaPredio" />
        <composite:attribute name="thisWVName" required="true"
                             shortDescription="valor del atributo widgetvar de este dialog"/>
        <composite:attribute name="ccIdsChain" required="true"
                             shortDescription="cadena que se usa para poder hacer updates y mostrar este widgetvar"/>
        <composite:attribute name="detallesPredioWV" required="true" />
        <composite:attribute name="idsComponentsToUpdate" required="false" default="formPS"
                             shortDescription="string con los ids de los componentes que se quieren actualizar al dar click en el boton de usar predio"/>
        <composite:attribute name="usePrediosMethod" required="false" method-signature="void usarPredioX()"
                             shortDescription="nombre del método que se ejecuta para usar el/los predios que se han seleccionado en el carrito.
                             Es opcional porque en alguna partes no se pinta ese botón en el cc"/>
        <composite:attribute name="consultaPredioPredioWV" required="true"
                             shortDescription="valor del atributo widget var de la ventana de consulta de predios"/>
        <composite:attribute name="usePrediosButtonRendered" required="false" default="false"
                             shortDescription="bandera para mostrar o no el botón de usar los predios seleccionados"/>
        <composite:attribute name="dynamicDialog" required="false" default="true"
                             shortDescription="bandera para definir si el dialog del composite es dinámico o no"/>

        <composite:attribute name="idsComponentsToUpdateEliminar" required="false" default=""
                             shortDescription="string con los ids de los componentes a actualizar desde el boton eliminar"/>


    </composite:interface>

    <composite:implementation>

        <div id="#{cc.clientId}">

            <p:dialog widgetVar="#{cc.attrs.thisWVName}"
                      modal="false" dynamic="#{cc.attrs.dynamicDialog}"
                      appendToBody="true" minHeight="300" minWidth="750"
                      header="Predios seleccionados"
                      closable="true" maximizable="true" minimizable="false">

                <h:form id="formPS">

                    <p:messages id="msjPredio" globalOnly="false" autoUpdate="true" />
                    <p:spacer height="5" width="0"/>

                    <h:panelGrid columns="3" id="botones">
                        <p:commandButton value="Limpiar predios seleccionados"
                                         id="limpiarPredios" action="#{cc.attrs.managedBean.limpiarPredios}"  
                                         icon="ui-icon-trash" update="prediosSeleccionadosDT, msjPredio"
                                         immediate="true" />
                        <p:spacer height="0" width="13"/>
                        <p:commandButton value="Usar predio seleccionado(s)"
                                         rendered="#{cc.attrs.usePrediosButtonRendered}"
                                         icon="ui-icon-transferthick-e-w"
                                         onclick="statusDialog2.show();"
                                         action="#{cc.attrs.usePrediosMethod}"
                                         update="#{cc.attrs.idsComponentsToUpdate}" 
                                         oncomplete="#{cc.attrs.thisWVName}.hide(); 
                                         #{cc.attrs.consultaPredioPredioWV}.hide();
                                         statusDialog2.hide();"
                                         immediate="true"/>                    
                    </h:panelGrid>        

                    <p:spacer height="10" />
                    <h:panelGrid columns="1">
                        <center>
                            <p:dataTable id="prediosSeleccionadosDT" 
                                         value="#{cc.attrs.managedBean.prediosSeleccionados}"
                                         var="currentPredio" paginator="true"
                                         rows="10"
                                         paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                         rowsPerPageTemplate="5,10,15" paginatorPosition="bottom"
                                         emptyMessage="No hay predios seleccionados">

                                <p:column headerText="Detalle">
                                    <p:commandButton title="Ver"
                                                     onstart="statusDialog2.show();"
                                                     action="#{cc.attrs.managedBean.cleanAllMB}"
                                                     oncomplete="statusDialog2.hide(); 
                                                     #{cc.attrs.ccIdsChain}:#{cc.attrs.detallesPredioWV}.show();"
                                                     update=":#{cc.attrs.ccIdsChain}:detallesPredioTV"
                                                     immediate="true" ajax="true" icon="ui-icon-search">
                                        <f:setPropertyActionListener value="#{currentPredio}"
                                                                     target="#{cc.attrs.managedBean.selectedPredio2}" />
                                    </p:commandButton>
                                    <p:commandButton title="Eliminar"
                                                     action="#{cc.attrs.managedBean.eliminarPredio}"
                                                     update=":#{cc.clientId}:formPS,:cpCC:consultaPredioForm:botones,#{cc.attrs.idsComponentsToUpdateEliminar}" immediate="true" ajax="true"
                                                     icon="ui-icon-trash">
                                        <f:setPropertyActionListener value="#{currentPredio}"
                                                                     target="#{cc.attrs.managedBean.selectedPredio2}" />
                                    </p:commandButton>
                                </p:column>

                                <p:column headerText="Departamento">
                                    <h:outputText value="#{currentPredio[0]}" />
                                </p:column>

                                <p:column headerText="Municipio">
                                    <h:outputText value="#{currentPredio[1]}" />
                                </p:column>

                                <p:column headerText="NIP">
                                    <h:outputText value="#{currentPredio[16]}" />
                                </p:column>

                                <p:column headerText="No. predial">
                                    <h:outputText value="#{currentPredio[14]}" />
                                </p:column>
                            </p:dataTable>
                        </center>
                    </h:panelGrid>

                </h:form>
            </p:dialog>

        </div>

    </composite:implementation>

</html>